//---     
#include "..\MultiSymbolExpert.mq5"
//---   
#include "Auxiliary.mqh"
#include "Enums.mqh"
#include "Errors.mqh"
#include "ToString.mqh"
#include "TradeFunctions.mqh"
#include "TradeSignals.mqh"
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void GetSymbols()
  {
   Symbols[0]=GetSymbolByName(Symbol_01);
   Symbols[1]=GetSymbolByName(Symbol_02);
  }
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
void GetIndicatorPeriod()
  {
   IndicatorPeriod[0]=IndicatorPeriod_01;
   IndicatorPeriod[1]=IndicatorPeriod_02;
  }
//+------------------------------------------------------------------+
//|   Take Profit                                     |
//+------------------------------------------------------------------+
void GetTakeProfit()
  {
   TakeProfit[0]=TakeProfit_01;
   TakeProfit[1]=TakeProfit_02;
  }
//+------------------------------------------------------------------+
//|   Stop Loss                                       |
//+------------------------------------------------------------------+
void GetStopLoss()
  {
   StopLoss[0]=StopLoss_01;
   StopLoss[1]=StopLoss_02;
  }
//+------------------------------------------------------------------+
//|   Trailing Stop                                   |
//+------------------------------------------------------------------+
void GetTrailingStop()
  {
   TrailingStop[0]=TrailingStop_01;
   TrailingStop[1]=TrailingStop_02;
  }
//+------------------------------------------------------------------+
//|   Reverse                                         |
//+------------------------------------------------------------------+
void GetReverse()
  {
   Reverse[0]=Reverse_01;
   Reverse[1]=Reverse_02;
  }
//+------------------------------------------------------------------+
//|   Lot                                             |
//+------------------------------------------------------------------+
void GetLot()
  {
   Lot[0]=Lot_01;
   Lot[1]=Lot_02;
  }
//+------------------------------------------------------------------+
//|   VolumeIncrease                                  |
//+------------------------------------------------------------------+
void GetVolumeIncrease()
  {
   VolumeIncrease[0]=VolumeIncrease_01;
   VolumeIncrease[1]=VolumeIncrease_02;
  }
//+------------------------------------------------------------------+
//|   VolumeIncreaseStep                              |
//+------------------------------------------------------------------+
void GetVolumeIncreaseStep()
  {
   VolumeIncreaseStep[0]=VolumeIncreaseStep_01;
   VolumeIncreaseStep[1]=VolumeIncreaseStep_02;
  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
void InitializeArrayNewBar()
  {
//---  
   ArrayInitialize(new_bar,0);
//---
   for(int s=0; s<NUMBER_OF_SYMBOLS; s++)
     {
      //---      
      if(Symbols[s]!="")
         //---    
         CheckNewBar(s);
     }
  }
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
void InitializeInputParameters()
  {
   GetSymbols();
   GetIndicatorPeriod();
   GetTakeProfit();
   GetStopLoss();
   GetTrailingStop();
   GetReverse();
   GetLot();
   GetVolumeIncrease();
   GetVolumeIncreaseStep();
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
void InitializeArrayHandles()
  {
   ArrayInitialize(spy_indicator_handles,INVALID_HANDLE);
   ArrayInitialize(signal_indicator_handles,INVALID_HANDLE);
  }
//+------------------------------------------------------------------+
//|      " "                  |
//+------------------------------------------------------------------+
string GetSymbolByName(string symbol)
  {
   string symbol_name="";   //    
//---    ,   
   if(symbol=="")
      return("");
//---       
   for(int s=0; s<SymbolsTotal(false); s++)
     {
      //---   
      symbol_name=SymbolName(s,false);
      //---      
      if(symbol==symbol_name)
        {
         //---     " "
         SymbolSelect(symbol,true);
         //---   
         return(symbol);
        }
     }
//---    ,   
   Print("C "+symbol+"    !");
   return("");
  }
//+------------------------------------------------------------------+
