//+------------------------------------------------------------------+
//|                                            MultiSymbolExpert.mq5 |
//|            Copyright 2013, https://login.mql5.com/ru/users/tol64 |
//|                                  Site, http://tol64.blogspot.com |
//+------------------------------------------------------------------+
#property copyright   "Copyright 2013, http://tol64.blogspot.com"
#property link        "http://tol64.blogspot.com"
#property description "email: hello.tol64@gmail.com"
#property version     "1.0"
//---   
#define NUMBER_OF_SYMBOLS 2
//---  
#define EXPERT_NAME MQL5InfoString(MQL5_PROGRAM_NAME)
//---    
#include <Trade/Trade.mqh>
//---  
CTrade   trade;
//---   
#include "Include/Enums.mqh"
#include "Include/InitializeArrays.mqh"
#include "Include/Errors.mqh"
#include "Include/TradeSignals.mqh"
#include "Include/TradeFunctions.mqh"
#include "Include/ToString.mqh"
#include "Include/Auxiliary.mqh"
//---   
sinput long   MagicNumber           = 777;      //  
sinput int    Deviation             = 10;       // 
//---
sinput string delimeter_00=""; // --------------------------------
sinput string Symbol_01             = "EURUSD"; //  1
input  int    IndicatorPeriod_01    = 5;        // |      
input  double TakeProfit_01         = 100;      // |      
input  double StopLoss_01           = 50;       // |      
input  double TrailingStop_01       = 10;       // |      
input  bool   Reverse_01            = true;     // |      
input  double Lot_01                = 0.1;      // |     
input  double VolumeIncrease_01     = 0.1;      // |       
input  double VolumeIncreaseStep_01 = 10;       // |        
//---
sinput string delimeter_01=""; // --------------------------------
sinput string Symbol_02             = "NZDUSD"; //  2
input  int    IndicatorPeriod_02    = 5;        // |      
input  double TakeProfit_02         = 100;      // |      
input  double StopLoss_02           = 50;       // |      
input  double TrailingStop_02       = 10;       // |      
input  bool   Reverse_02            = true;     // |      
input  double Lot_02                = 0.1;      // |     
input  double VolumeIncrease_02     = 0.1;      // |       
input  double VolumeIncreaseStep_02 = 10;       // |        

//---     
string Symbols[NUMBER_OF_SYMBOLS];            // 
int    IndicatorPeriod[NUMBER_OF_SYMBOLS];    //  
double TakeProfit[NUMBER_OF_SYMBOLS];         //  
double StopLoss[NUMBER_OF_SYMBOLS];           //  
double TrailingStop[NUMBER_OF_SYMBOLS];       //  
bool   Reverse[NUMBER_OF_SYMBOLS];            //  
double Lot[NUMBER_OF_SYMBOLS];                // 
double VolumeIncrease[NUMBER_OF_SYMBOLS];     //   
double VolumeIncreaseStep[NUMBER_OF_SYMBOLS]; //    

//---    -
int spy_indicator_handles[NUMBER_OF_SYMBOLS];
//---    
int signal_indicator_handles[NUMBER_OF_SYMBOLS];
//---      
struct PriceData
  {
   double            value[];
  };
PriceData open[NUMBER_OF_SYMBOLS];      //   
PriceData high[NUMBER_OF_SYMBOLS];      //   
PriceData low[NUMBER_OF_SYMBOLS];       //   
PriceData close[NUMBER_OF_SYMBOLS];     //   
PriceData indicator[NUMBER_OF_SYMBOLS]; //   
//---       
struct Datetime
  {
   datetime          time[];
  };
Datetime lastbar_time[NUMBER_OF_SYMBOLS];
//---        
datetime new_bar[NUMBER_OF_SYMBOLS];
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
void OnInit()
  {
//---    
   InitializeInputParameters();
//---    
   InitializeArrayHandles();
//---   
   GetSpyHandles();
//---   
   GetIndicatorHandles();
//---   
   InitializeArrayNewBar();
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---     
   Print(GetDeinitReasonText(reason));
//---    
   if(reason==REASON_REMOVE)
     {
      //---   
      for(int s=NUMBER_OF_SYMBOLS-1; s>=0; s--)
        {
         IndicatorRelease(spy_indicator_handles[s]);
         IndicatorRelease(signal_indicator_handles[s]);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,         //  
                  const long &lparam,   //    long
                  const double &dparam, //    double
                  const string &sparam) //    string
  {
//---    
   if(id>=CHARTEVENT_CUSTOM)
     {
      //--- ,   
      if(CheckTradingPermission()>0)
         return;
      //---    ""
      if(lparam==CHARTEVENT_TICK)
        {
         //---      
         CheckSignalsAndTrade();
         return;
        }
     }
  }
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
void CheckSignalsAndTrade()
  {
//---     
   for(int s=0; s<NUMBER_OF_SYMBOLS; s++)
     {
      //---      
      if(Symbols[s]!="")
        {
         //---    ,    
         if(!CheckNewBar(s))
            continue;
         //---    
         else
           {
            //---   .   ,    
            if(!GetIndicatorsData(s))
               continue;
            //---                  
            GetBarsData(s);
            //---    
            TradingBlock(s);
            //--- 
            ModifyTrailingStop(s);
           }
        }
     }
  }
//+------------------------------------------------------------------+
